text: str = open("example.txt", "r").read()

_value: int = 0

lines = text.splitlines()

CARDS = "AKQJT98765432"

def get_same(string: str):
	sames = {"key": string}
	for card in CARDS:
		if string.count(card) != 0:
			bozo: list = sames.get(string.count(card), "")
			bozo += (card)
			sames.update({string.count(card): bozo})
	return sames

sames = []
for line in lines:
	bozo: [str] = line.split()
	same = get_same(bozo[0])
	same.update({"value": int(bozo[1])})
	sames.append(same)


def get_highest(cards1, cards2, i):
	if (cards1 == cards2):
		return 0
	if (i != 1):
		l1 = len(cards1)
		l2 = len(cards2)
		if (l1 > l2):
			return 1
		if (l2 > l1):
			return 2
	for char1, char2 in zip(cards1, cards2):
		if (char2 == char1):
			continue
		return 1 + (CARDS.index(char1) > CARDS.index(char2))
	return 0

def get_index(lst: [dict], key: str):
	for i, hand in enumerate(lst):
		if (hand.get("key") == key):
			return i

sort = [sames[0]]
for same in sames[1:]:
	places = []
	opponents: [dict] = sort.copy()
	for card_index in range(5, 0, -1):
		new = []
		for opponent in opponents:
			my_cards = same.get(card_index, "")
			opponent_cards = opponent.get(card_index, "")
			highest = get_highest(my_cards, opponent_cards, card_index)
			if (highest == 0):
				new.append(opponent)
			elif (highest == 1):
				places.append(get_index(sort, opponent.get("key")))
		opponents = new
		if (places != []):
			break
	if (places == []):
		places = [len(sort)]
	place = min(places)
	sort.insert(place, same)

for i, line in enumerate(lines):
	key, value = line.split()
	for j, bozo in enumerate(sort):
		if (bozo.get("key", "") == key):
			rank: int = (len(lines) - j)
			_value += rank * bozo.get("value")
			print(f'{rank}, {bozo.get("key")} {bozo.get("value")}')
			break

print(_value)